//***************************************************************************
//  Project.....:  
//  Version.....: 1.0
//  Author......: Chiper (digitalchip.ru)
//  Device(s)...: ATMega..., ATTiny...
//  Compiler....: WinAVR
//  Description.:  RGB-   
//				    ( )
//  Data........: 01.11.11
//***************************************************************************

#include <avr/io.h>	//  /
   
//***************************************************************************
//***  

// ,    RGB-
#define LED_PORT PORTB
#define LED_PIN  PINB
#define LED_DDR  DDRB

//  ,     RGB-
#define R_PIN 0		// 
#define G_PIN 1		//
#define B_PIN 2		//

#define delval 1500 // -    (/)

//***************************************************************************
//***  

#define nop() {asm("nop");}//    
    
//  
void delay_cycl(int delay) { for (int i=delay;i>0;i--) nop (); }
     
//       
void led_pin_off(int pin,int delay) { LED_PORT &= ~_BV(pin); delay_cycl(delay); }

//       
void led_pin_on(int pin,int delay) { LED_PORT |= _BV(pin); delay_cycl(delay); }
     

//    
void led_fade_in(int pin)
{	
	unsigned int i,p;
   	
	for (i = 0; i < delval; i++)
   	{
    	p=delval-i;
   		led_pin_on(pin, i);
    	led_pin_off(pin,p);
   	}
}

//    
void led_fade_out(int pin)
{	
	unsigned int i,p;
   	
	for (i = 0; i < delval; i++)
   	{
    	p=delval-i;
   		led_pin_on(pin, p);
    	led_pin_off(pin,i);
   	}
}

//***************************************************************************
//***  

int main( void )
{
	//     LED_PORT
    LED_DDR |= _BV(R_PIN);//
    LED_DDR |= _BV(G_PIN);//
    LED_DDR |= _BV(B_PIN);//
     
    //  ###############################################
    LED_PIN |= _BV(R_PIN);//
    LED_PIN |= _BV(G_PIN);//
    LED_PIN |= _BV(B_PIN);//
     
	while(1) // . 
	{	//   : R->RG->G->GB->B->BR->R

    	//  
    	led_pin_on(R_PIN,0);
     
    	//   
		led_fade_in(G_PIN);

    	//   
    	led_pin_on(G_PIN,0);
     
    	//   
		led_fade_out(R_PIN);
		     
    	//   
    	led_pin_on(G_PIN,0);
     
    	//   
		led_fade_in(B_PIN);     

    	//   
    	led_pin_on(B_PIN,0);
     
    	//   
		led_fade_out(G_PIN);
		     
    	//   
    	led_pin_on(B_PIN,0);
     
    	//   
		led_fade_in(R_PIN);
		     
    	//   
    	led_pin_on(R_PIN,0);
     
    	//   
	    led_fade_out(B_PIN);

	} //     
}
